Index: kernel/sql/common/cleandata.sql
===================================================================
--- kernel/sql/common/cleandata.sql	(revision 20604)
+++ kernel/sql/common/cleandata.sql	(working copy)
@@ -3404,7 +3404,7 @@
   status
 ) VALUES (
   4,
-  2,
+  1,
   10,
   2,
   0,
@@ -4257,7 +4257,7 @@
   3,
   0,
   'anonymous',
-  2
+  1
 );
 INSERT INTO ezcontentobject_attribute (
   attribute_original_id,
@@ -4286,7 +4286,7 @@
   3,
   0,
   'user',
-  2
+  1
 );
 INSERT INTO ezcontentobject_attribute (
   attribute_original_id,
@@ -4315,7 +4315,7 @@
   3,
   0,
   '',
-  2
+  1
 );
 INSERT INTO ezcontentobject_attribute (
   attribute_original_id,
@@ -5591,7 +5591,7 @@
   3,
   0,
   '',
-  2
+  1
 );
 INSERT INTO ezcontentobject_attribute (
   attribute_original_id,
@@ -5649,7 +5649,7 @@
   3,
   0,
   '',
-  2
+  1
 );
 INSERT INTO ezcontentobject_attribute (
   attribute_original_id,
@@ -6012,7 +6012,7 @@
   'eng-GB',
   1,
   10,
-  2,
+  3,
   'Anonymous User',
   'eng-GB'
 );
@@ -6115,21 +6115,6 @@
   real_translation
 ) VALUES (
   'eng-GB',
-  2,
-  10,
-  3,
-  'Anonymous User',
-  'eng-GB'
-);
-INSERT INTO ezcontentobject_name (
-  content_translation,
-  content_version,
-  contentobject_id,
-  language_id,
-  name,
-  real_translation
-) VALUES (
-  'eng-GB',
   1,
   45,
   3,
@@ -6592,7 +6577,7 @@
 ) VALUES (
   10,
   1,
-  2,
+  1,
   3,
   0,
   0,
@@ -7050,7 +7035,7 @@
   1072180405,
   1,
   0,
-  2,
+  1,
   0
 );
 INSERT INTO ezcontentobject_version (
Index: share/db_data.dba
===================================================================
--- share/db_data.dba	(revision 20604)
+++ share/db_data.dba	(working copy)
@@ -1968,7 +1968,7 @@
       2 => 
       array (
         0 => '4',
-        1 => '2',
+        1 => '1',
         2 => '10',
         3 => '2',
         4 => '0',
@@ -2468,7 +2468,7 @@
         9 => '3',
         10 => '0',
         11 => 'anonymous',
-        12 => '2',
+        12 => '1',
       ),
       16 => 
       array (
@@ -2484,7 +2484,7 @@
         9 => '3',
         10 => '0',
         11 => 'user',
-        12 => '2',
+        12 => '1',
       ),
       17 => 
       array (
@@ -2500,7 +2500,7 @@
         9 => '3',
         10 => '0',
         11 => '',
-        12 => '2',
+        12 => '1',
       ),
       18 => 
       array (
@@ -3249,7 +3249,7 @@
         9 => '3',
         10 => '0',
         11 => '',
-        12 => '2',
+        12 => '1',
       ),
       62 => 
       array (
@@ -3281,7 +3281,7 @@
         9 => '3',
         10 => '0',
         11 => '',
-        12 => '2',
+        12 => '1',
       ),
       64 => 
       array (
@@ -3532,7 +3532,7 @@
         0 => 'eng-GB',
         1 => '1',
         2 => '10',
-        3 => '2',
+        3 => '3',
         4 => 'Anonymous User',
         5 => 'eng-GB',
       ),
@@ -3593,22 +3593,13 @@
       9 => 
       array (
         0 => 'eng-GB',
-        1 => '2',
-        2 => '10',
-        3 => '3',
-        4 => 'Anonymous User',
-        5 => 'eng-GB',
-      ),
-      10 => 
-      array (
-        0 => 'eng-GB',
         1 => '1',
         2 => '45',
         3 => '3',
         4 => 'Setup',
         5 => 'eng-GB',
       ),
-      11 => 
+      10 => 
       array (
         0 => 'eng-GB',
         1 => '1',
@@ -3617,7 +3608,7 @@
         4 => 'Images',
         5 => 'eng-GB',
       ),
-      12 => 
+      11 => 
       array (
         0 => 'eng-GB',
         1 => '1',
@@ -3626,7 +3617,7 @@
         4 => 'Files',
         5 => 'eng-GB',
       ),
-      13 => 
+      12 => 
       array (
         0 => 'eng-GB',
         1 => '1',
@@ -3635,7 +3626,7 @@
         4 => 'Multimedia',
         5 => 'eng-GB',
       ),
-      14 => 
+      13 => 
       array (
         0 => 'eng-GB',
         1 => '1',
@@ -3644,7 +3635,7 @@
         4 => 'Common INI settings',
         5 => 'eng-GB',
       ),
-      15 => 
+      14 => 
       array (
         0 => 'eng-GB',
         1 => '1',
@@ -3653,7 +3644,7 @@
         4 => 'eZ publish',
         5 => 'eng-GB',
       ),
-      16 => 
+      15 => 
       array (
         0 => 'eng-GB',
         1 => '2',
@@ -3662,7 +3653,7 @@
         4 => 'eZ publish',
         5 => 'eng-GB',
       ),
-      17 => 
+      16 => 
       array (
         0 => 'eng-GB',
         1 => '3',
@@ -3671,7 +3662,7 @@
         4 => 'eZ publish',
         5 => 'eng-GB',
       ),
-      18 => 
+      17 => 
       array (
         0 => 'eng-GB',
         1 => '1',
@@ -3880,7 +3871,7 @@
       array (
         0 => '10',
         1 => '1',
-        2 => '2',
+        2 => '1',
         3 => '3',
         4 => '0',
         5 => '0',
@@ -4157,7 +4148,7 @@
         6 => '1072180405',
         7 => '1',
         8 => '0',
-        9 => '2',
+        9 => '1',
         10 => '0',
       ),
       8 => 