Index: lib/ezi18n/classes/eztstranslator.php
===================================================================
--- lib/ezi18n/classes/eztstranslator.php	(revision 22635)
+++ lib/ezi18n/classes/eztstranslator.php	(working copy)
@@ -404,15 +404,38 @@
                 $childName = $message_child->tagName;
                 if ( $childName  == "source" )
                 {
-                    $source_el = $message_child->firstChild;
-                    $source = $source_el->nodeValue;
+                    if ( $message_child->childNodes->length > 0 )
+                    {
+                        $source = '';
+                        foreach ( $message_child->childNodes as $textEl )
+                        {
+                            if ( $textEl instanceof DOMText )
+                            {
+                                $source .= $textEl->nodeValue;
+                            }
+                            else if ( $textEl instanceof DOMElement && $textEl->tagName == 'byte' )
+                            {
+                                $source .= chr( intval( '0' . $textEl->getAttribute( 'value' ) ) );
+                            }
+                        }
+                    }
                 }
                 else if ( $childName == "translation" )
                 {
-                    $translation_el = $message_child->firstChild;
-                    if ( $translation_el )
+                    if ( $message_child->childNodes->length > 0 )
                     {
-                        $translation = $translation_el->nodeValue;
+                        $translation = '';
+                        foreach ( $message_child->childNodes as $textEl )
+                        {
+                            if ( $textEl instanceof DOMText )
+                            {
+                                $translation .= $textEl->nodeValue;
+                            }
+                            else if ( $textEl instanceof DOMElement && $textEl->tagName == 'byte' )
+                            {
+                                $translation .= chr( intval( '0' . $textEl->getAttribute( 'value' ) ) );
+                            }
+                        }
                     }
                 }
                 else if ( $childName == "comment" )
Index: schemas/translation/ts.rng
===================================================================
--- schemas/translation/ts.rng	(revision 22635)
+++ schemas/translation/ts.rng	(working copy)
@@ -1,57 +1,58 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<grammar ns="" xmlns="http://relaxng.org/ns/structure/1.0" datatypeLibrary="http://www.w3.org/2001/XMLSchema-datatypes">
-  <start>
-    <element name="TS">
-      <optional>
-        <attribute name="language">
-          <data type="NCName"/>
-        </attribute>
-      </optional>
-      <optional>
-        <attribute name="version">
-          <data type="decimal"/>
-        </attribute>
-      </optional>
-      <optional>
-        <element name="defaultcodec">
-          <empty/>
-        </element>
-      </optional>
-      <oneOrMore>
-        <element name="context">
-          <element name="name">
-            <text/>
-          </element>
-          <oneOrMore>
-            <element name="message">
-              <optional>
-                <element name="location">
-                  <attribute name="filename"/>
-                  <attribute name="line">
-                    <data type="integer"/>
-                  </attribute>
-                </element>
-              </optional>
-              <element name="source">
-                <text/>
-              </element>
-              <optional>
-                <element name="comment">
-                  <text/>
-                </element>
-              </optional>
-              <element name="translation">
-                <optional>
-                  <attribute name="type">
-                    <data type="NCName"/>
-                  </attribute>
-                </optional>
-                <text/>
-              </element>
-            </element>
-          </oneOrMore>
-        </element>
-      </oneOrMore>
-    </element>
-  </start>
-</grammar>
+<?xml version="1.0" encoding="UTF-8"?>
+<grammar ns="" xmlns="http://relaxng.org/ns/structure/1.0" datatypeLibrary="http://www.w3.org/2001/XMLSchema-datatypes">
+  <start>
+    <element name="TS">
+      <optional>
+        <attribute name="language">
+          <data type="NCName"/>
+        </attribute>
+      </optional>
+      <optional>
+        <attribute name="version">
+          <data type="decimal"/>
+        </attribute>
+      </optional>
+      <optional>
+        <element name="defaultcodec">
+          <empty/>
+        </element>
+      </optional>
+      <oneOrMore>
+        <element name="context">
+          <element name="name">
+            <text/>
+          </element>
+          <oneOrMore>
+            <element name="message">
+              <element name="source">
+                <oneOrMore>
+                  <choice>
+                    <text/>
+                    <element name="byte">
+                      <attribute name="value">
+                        <data type="NCName"/>
+                      </attribute>
+                    </element>
+                  </choice>
+                </oneOrMore>
+              </element>
+              <optional>
+                <element name="comment">
+                  <text/>
+                </element>
+              </optional>
+              <element name="translation">
+                <optional>
+                  <attribute name="type">
+                    <data type="NCName"/>
+                  </attribute>
+                </optional>
+                <text/>
+              </element>
+            </element>
+          </oneOrMore>
+        </element>
+      </oneOrMore>
+    </element>
+  </start>
+</grammar>