### Eclipse Workspace Patch 1.0
#P trunk
Index: design/admin/templates/children.tpl
===================================================================
--- design/admin/templates/children.tpl	(revision 22820)
+++ design/admin/templates/children.tpl	(working copy)
@@ -189,12 +189,12 @@
     <div class="left">
     <input type="hidden" name="NodeID" value="{$node.node_id}" />
 
-   {let can_create_classes=fetch( content, can_instantiate_class_list, hash( group_id, array( ezini( 'ClassGroupIDs', 'Users', 'content.ini' ), ezini( 'ClassGroupIDs', 'Setup', 'content.ini' ) ), parent_node, $node, filter_type, exclude ) )}
+   {if $node.path_array|contains( ezini( 'NodeSettings', 'UserRootNode', 'content.ini' ) )}
+       {def $can_create_classes = fetch( 'content', 'can_instantiate_class_list', hash( 'group_id', ezini( 'ClassGroupIDs', 'Users', 'content.ini' ), 'parent_node', $node ) )}
+   {else}
+       {def $can_create_classes = fetch( 'content', 'can_instantiate_class_list', hash( 'group_id', array( ezini( 'ClassGroupIDs', 'Users', 'content.ini' ), ezini( 'ClassGroupIDs', 'Setup', 'content.ini' ) ), 'parent_node', $node, 'filter_type', 'exclude' ) )}
+   {/if}
 
-   {section show=$node.path_array|contains(ezini( 'NodeSettings', 'UserRootNode', 'content.ini' ) )}
-          {set can_create_classes=fetch( content, can_instantiate_class_list, hash( group_id, ezini( 'ClassGroupIDs', 'Users', 'content.ini' ), parent_node, $node ) )}
-   {/section}
-
     {def $can_create_languages=fetch( content, prioritized_languages )}
 
     {if ne( $can_create_languages|count, 1 )}
@@ -279,7 +279,7 @@
     </script>
     {/if}
 
-    {if and(eq( $can_create_languages|count, 1 ), is_set( $can_create_languages[0] ) )}
+    {if and( is_set( $can_create_languages[0] ), eq( $can_create_languages|count, 1 ) )}
         <select id="ClassID" name="ClassID" title="{'Use this menu to select the type of item you want to create then click the "Create here" button. The item will be created in the current location.'|i18n( 'design/admin/node/view/full' )|wash()}">
     {else}
         <select id="ClassID" name="ClassID" onchange="updateLanguageSelector(this)" title="{'Use this menu to select the type of item you want to create then click the "Create here" button. The item will be created in the current location.'|i18n( 'design/admin/node/view/full' )|wash()}">
@@ -291,7 +291,7 @@
         {/section}
     </select>
 
-    {if and(eq( $can_create_languages|count, 1 ), is_set( $can_create_languages[0] ) )}
+    {if and( is_set( $can_create_languages[0] ), eq( $can_create_languages|count, 1 ) )}
         <input name="ContentLanguageCode" value="{$can_create_languages[0].locale}" type="hidden" />
     {else}
         <select name="ContentLanguageCode" onchange="checkLanguageSelector(this)" title="{'Use this menu to select the language you want to use for the creation then click the "Create here" button. The item will be created in the current location.'|i18n( 'design/admin/node/view/full' )|wash()}">
@@ -300,9 +300,9 @@
             {/foreach}
        </select>
     {/if}
-    {undef $can_create_languages}
-    {/let}
+    {undef $can_create_languages $can_create_classes}
 
+
     <input class="button" type="submit" name="NewButton" value="{'Create here'|i18n( 'design/admin/node/view/full' )}" title="{'Create a new item in the current location. Use the menu on the left to select the type of  item.'|i18n( 'design/admin/node/view/full' )}" />
     <input type="hidden" name="ContentNodeID" value="{$node.node_id}" />
     <input type="hidden" name="ContentObjectID" value="{$node.contentobject_id}" />
Index: design/admin/templates/contentstructuremenu/content_structure_menu_dynamic.tpl
===================================================================
--- design/admin/templates/contentstructuremenu/content_structure_menu_dynamic.tpl	(revision 22820)
+++ design/admin/templates/contentstructuremenu/content_structure_menu_dynamic.tpl	(working copy)
@@ -525,7 +525,7 @@
 {cache-block keys=$root_node_id expiry="0"}
 
     var rootNode = {ldelim}{*
-        *}"node_id":{$root_node.node_id},{*
+        *}"node_id":{$root_node_id},{*
         *}"object_id":{$root_node.object.id},{*
         *}"class_id":{$root_node.object.contentclass_id},{*
         *}"has_children":{if $root_node.children_count}true{else}false{/if},{*
@@ -533,13 +533,13 @@
         *}"url":{$root_node.url|ezurl},{*
         *}"modified_subnode":{$root_node.modified_subnode},{*
         *}"languages":["{$root_node.object.language_codes|implode('", "')}"],{*
-        *}"class_list":[{foreach fetch('content','can_instantiate_class_list',hash('parent_node',$root_node.node_id, 'filter_type', $filter_type, 'group_id', $filter_groups)) as $class}{$class.id}{delimiter},{/delimiter}{/foreach}]{rdelim};
+        *}"class_list":[{foreach fetch('content','can_instantiate_class_list',hash('parent_node',$root_node, 'filter_type', $filter_type, 'group_id', $filter_groups)) as $class}{$class.id}{delimiter},{/delimiter}{/foreach}]{rdelim};
 
     document.writeln( '<ul id="content_tree_menu">' );
     document.writeln( treeMenu.generateEntry( rootNode, false, true ) );
     document.writeln( '</ul>' );
 
-    treeMenu.load( false, {$root_node.node_id}, {$root_node.modified_subnode} );
+    treeMenu.load( false, {$root_node_id}, {$root_node.modified_subnode} );
 {/cache-block}
 
 // -->