Index: trunk/packages/ezjscore_extension/ezextension/ezjscore/design/admin/templates/page_head.tpl
===================================================================
--- trunk/packages/ezjscore_extension/ezextension/ezjscore/design/admin/templates/page_head.tpl	(revision 25)
+++ trunk/packages/ezjscore_extension/ezextension/ezjscore/design/admin/templates/page_head.tpl	(working copy)
@@ -47,7 +47,9 @@
     {include uri="design:link.tpl" enable_help=$enable_help enable_link=$enable_link}
 {/section}
 
-{* Load JavaScript dependencys *}
-{ezscript_load()}
+{if fetch( 'setup', 'minor_version' )|lt( 2 )}
+    {include uri='design:page_head_style.tpl' load_main_css=false()}
+    {include uri='design:page_head_script.tpl' load_javascript_list=false()}
+{/if}
 
 {/default}
Index: trunk/packages/ezjscore_extension/ezextension/ezjscore/design/admin/templates/page_head_script.tpl
===================================================================
--- trunk/packages/ezjscore_extension/ezextension/ezjscore/design/admin/templates/page_head_script.tpl	(revision 0)
+++ trunk/packages/ezjscore_extension/ezextension/ezjscore/design/admin/templates/page_head_script.tpl	(revision 0)
@@ -0,0 +1,11 @@
+{* DO NOT EDIT THIS FILE! Use an override template instead. *}
+
+{if is_unset( $load_javascript_list )}
+ {def $load_javascript_list = true()}
+{/if}
+
+{if $load_javascript_list}
+ {ezscript_load( ezini( 'JavaScriptSettings', 'JavaScriptList', 'design.ini' ) )}
+{else}
+ {ezscript_load()}
+{/if}
\ No newline at end of file

Property changes on: trunk\packages\ezjscore_extension\ezextension\ezjscore\design\admin\templates\page_head_script.tpl
___________________________________________________________________
Added: svn:eol-style
   + native

Index: trunk/packages/ezjscore_extension/ezextension/ezjscore/design/admin/templates/page_head_style.tpl
===================================================================
--- trunk/packages/ezjscore_extension/ezextension/ezjscore/design/admin/templates/page_head_style.tpl	(revision 0)
+++ trunk/packages/ezjscore_extension/ezextension/ezjscore/design/admin/templates/page_head_style.tpl	(revision 0)
@@ -0,0 +1,90 @@
+{* DO NOT EDIT THIS FILE! Use an override template instead. *}
+
+{if is_unset( $load_css_file_list )}
+    {def $load_css_file_list = true()}
+{/if}
+
+{if is_unset( $load_main_css )}
+    {def $load_main_css = true()}
+{/if}
+
+{if $load_main_css}
+
+  {* load main css files and requried css files *}
+  {if $load_css_file_list}
+    {ezcss_load( array( 'core.css', 'site.css', 'debug.css', ezini( 'StylesheetSettings', 'CSSFileList', 'design.ini' ) ) )}
+  {else}
+    {ezcss_load( array( 'core.css', 'site.css', 'debug.css' ) )}
+  {/if}
+
+{def $dynamic_csm_disabled = ezini('TreeMenu','Dynamic','contentstructuremenu.ini')|ne('enabled')}
+
+
+{if or( $dynamic_csm_disabled, $#admin_left_width, $#hide_right_menu )}
+<style type="text/css">
+{if $#hide_right_menu}
+    div#maincontent {ldelim} margin-right: 0.4em; {rdelim}
+{/if}
+
+{if $#admin_left_width}
+    {def $left_menu_widths = ezini( 'LeftMenuSettings', 'MenuWidth', 'menu.ini')
+         $left_menu_width=$left_menu_widths[$admin_left_width]}
+    div#leftmenu {ldelim} width: {$left_menu_width|int}em; {rdelim}
+    div#maincontent {ldelim} margin-left: {$left_menu_width|int}.5em; {rdelim}
+    {undef $left_menu_widths $left_menu_width}
+{/if}
+
+{if $dynamic_csm_disabled}
+    div#contentstructure ul#content_tree_menu ul li {ldelim} padding-left: 0; {rdelim}
+    div#contentstructure ul#content_tree_menu ul ul {ldelim} margin-left: 20px; {rdelim}
+{/if}
+</style>
+{/if}
+
+{literal}
+<!--[if lt IE 8.0]>
+<style type="text/css">
+div#leftmenu div.box-bc, div#rightmenu div.box-bc { border-bottom: 1px solid #bfbeb6; /* Strange IE bug fix */ }
+div#contentstructure { overflow-x: auto; overflow-y: hidden; } /* hide vertical scrollbar in IE */
+div.menu-block li { width: 16.66%; } /* Avoid width bug in IE */
+div.notranslations li { width: 19%; } /* Avoid width bug in IE */
+div.context-user div.menu-block li { width: 14%; } /* Avoid width bug in IE */
+input.button, input.button-disabled { padding: 0 0.5em 0 0.5em; overflow: visible; }
+input.box, textarea.box { width: 98%; }
+td input.box, td textarea.box { width: 97%; }
+div#search p.select { margin-top: 0; }
+div#search p.advanced { margin-top: 0.3em; }
+div.content-navigation div.mainobject-window div.fixedsize { float: none; overflow: scroll; }
+div.fixedsize input.box, div.fixedsize textarea.box, div.fixedsize table.list { width: 95%; }
+a.openclose img, span.openclose img { margin-right: 4px; }
+div#fix { overflow: hidden; }
+</style>
+<![endif]-->
+<!--[if lt IE 6.0]>
+<style type="text/css">
+div#maincontent div.context-block { width: 100%; } /* Avoid width bug in IE 5.5 */
+div#maincontent div#maincontent-design { width: 98%; } /* Avoid width bug in IE 5.5 */
+</style>
+<![endif]-->
+<!--[if IE 6.0]>
+<style type="text/css">
+div#maincontent div.box-bc { border-bottom: 1px solid #bfbfb7; /* Strange IE bug fix */ }
+div#leftmenu-design { margin: 0.5em 4px 0.5em 0.5em; }
+</style>
+<![endif]-->
+{/literal}
+
+<!--[if lt IE 7.0]>
+<script type="text/javascript">
+    var emptyIcon16 = {'16x16.gif'|ezimage};
+    var emptyIcon32 = {'32x32.gif'|ezimage};
+</script>
+<script type="text/javascript" src={'javascript/tools/eziepngfix.js'|ezdesign}></script>
+<![endif]-->
+
+{else}
+
+  {* load requried css files *}
+ {ezcss_load()}
+
+{/if}

Property changes on: trunk\packages\ezjscore_extension\ezextension\ezjscore\design\admin\templates\page_head_style.tpl
___________________________________________________________________
Added: svn:eol-style
   + native

Index: trunk/packages/ezjscore_extension/ezextension/ezjscore/design/ezwebin/templates/page_head_style.tpl
===================================================================
--- trunk/packages/ezjscore_extension/ezextension/ezjscore/design/ezwebin/templates/page_head_style.tpl	(revision 0)
+++ trunk/packages/ezjscore_extension/ezextension/ezjscore/design/ezwebin/templates/page_head_style.tpl	(revision 0)
@@ -0,0 +1,27 @@
+{if is_unset( $load_css_file_list )}
+    {def $load_css_file_list = true()}
+{/if}
+
+{if $load_css_file_list}
+  {ezcss_load( array( 'core.css',
+                      'debug.css',
+                      'pagelayout.css',
+                      'content.css',
+                      'websitetoolbar.css',
+                      ezini( 'StylesheetSettings', 'CSSFileList', 'design.ini' ),
+                      ezini('StylesheetSettings','ClassesCSS','design.ini')|ezroot(no),
+                      ezini('StylesheetSettings','SiteCSS','design.ini')|ezroot(no) ) )}
+{else}
+  {ezcss_load( array( 'core.css',
+                      'debug.css',
+                      'pagelayout.css',
+                      'content.css',
+                      'websitetoolbar.css',
+                      ezini('StylesheetSettings','ClassesCSS','design.ini')|ezroot(no),
+                      ezini('StylesheetSettings','SiteCSS','design.ini')|ezroot(no) ) )}
+{/if}
+
+<link rel="stylesheet" type="text/css" href={"stylesheets/print.css"|ezdesign} media="print" />
+<!-- IE conditional comments; for bug fixes for different IE versions -->
+<!--[if IE 5]>     <style type="text/css"> @import url({"stylesheets/browsers/ie5.css"|ezdesign(no)});    </style> <![endif]-->
+<!--[if lte IE 7]> <style type="text/css"> @import url({"stylesheets/browsers/ie7lte.css"|ezdesign(no)}); </style> <![endif]-->
\ No newline at end of file

Property changes on: trunk\packages\ezjscore_extension\ezextension\ezjscore\design\ezwebin\templates\page_head_style.tpl
___________________________________________________________________
Added: svn:eol-style
   + native